<?php

/**
 * Page callback for admin/structure/cfrpreset/%/code
 *
 * @param string $interface
 *
 * @return string|array
 */
function _cfrpreset_interface_code_page($interface) {

  $html = '';

  if (!interface_exists($interface) && !class_exists($interface)) {
    $html .= t('There is no class or interface by this name.');
  }
  elseif (null === $php = _cfrpreset_class_get_php($interface)) {
    $html .= t('The class has no doc comment.');
  }
  else {
    $html .= _cfrpreset_highlight_php($php);
  }

  return $html;
}

/**
 * @param string $class
 *
 * @return string|null
 */
function _cfrpreset_class_get_php($class) {

  $reflectionClass = new ReflectionClass($class);

  $filename = $reflectionClass->getFileName();
  if (FALSE === $filename || !is_readable($filename)) {
    return NULL;
  }

  dpm($filename);

  return file_get_contents($filename);
}
